# zipd

[![EditorConfig-enabled](https://img.shields.io/badge/EditorConfig-enabled-brightgreen?logo=EditorConfig&logoColor=white)](https://editorconfig.org/)
[![pre-commit-enabled](https://img.shields.io/badge/pre--commit-enabled-brightgreen?logo=pre-commit&logoColor=white)](https://pre-commit.com)
[![Python-3.10+](https://img.shields.io/badge/Python-3.10+-informational?logo=Python&logoColor=white)](https://www.python.org)
[![CodeStyle-ruff](https://img.shields.io/badge/CodeStyle-black-informational)](https://astral.sh/ruff)


Convenience utility for recursively zipping up a directory (or "folder").
Formerly known as `zipdir`.


[begintoc]: #

## Contents

- [Features](#features)
- [Requirements](#requirements)
- [Installing](#installing)
- [References](#references)

[endtoc]: # (Generated by mark-toc pre-commit hook)


## Features

- Can filter some revision control files out of resulting zipfile.
- Can use [.gitignore][] file for filtering.
- Can zip up a [git][] workspace including the `.git` folder.
- Can make a fresh zipfile or reuse an existing one.
- Can pass options to **zip**.
- Dry run.


## Requirements

- A [Python](https://www.python.org/) interpreter, version 3.10 or later
- [zip][] installed somewhere on your path


## Installing

It is recommended to install **zipd** in its own virtual environment (for example, using [uv][]).

Once you have [uv installed][uv-install], you can use it to install `zipd` as follows:

    uv tool install zipd

Then:

    uv tool run zipd --help

or:

    uvx zipd --help


## References

- [zip][]
- [git][] ([.gitignore][])
- [gitignore-parser][]
- [uv][] ([install][uv-install])


 [git]: https://git-scm.com/
 [.gitignore]: https://git-scm.com/docs/gitignore
 [gitignore-parser]: https://github.com/mherrmann/gitignore_parser
 [python]: https://www.python.org/
 [uv]: https://github.com/astral-sh/uv
 [uv-install]: https://docs.astral.sh/uv/getting-started/installation
 [zip]: https://infozip.sourceforge.net/Zip.html
